#!bin/bash
# dump pickle
# 2: load, 3: save
START_DATE="2014-09-01"
DISK_MODEL="Hitachi HDS722020ALA330"
DATA_PATH="~/trace/smart/all/"
TRAIN_PATH="./hi7_train_p30n7v30_fix_20/"
TEST_PATH="./hi7_test_p30n7v30_fix_20/"
ITER_DAYS=10
PATH_FEATUERS="features_erg/hi7_all.txt"
OPTIONS="3,4"
FORGET_TYPE="sliding"
LABEL_DAYS=20
POSITIVE_WINDOW=30
NEGATIVE_WINDOW=7
VALIDATION_WINDOW=30

REPORT_NAME="hi7_p30n7v30_fix_20"
SAVE_DIR="save_model/"
PATH_LOAD="${SAVE_DIR}${LOAD_NAME}.pickle"
PATH_SAVE="${SAVE_DIR}${REPORT_NAME}.pickle"
TIME_PATH="time_${REPORT_NAME}.txt"

if [ ! -d ${TRAIN_PATH} ]; then
mkdir $TRAIN_PATH
mkdir $TEST_PATH
fi

if [ ! -d ${SAVE_DIR} ]; then
mkdir $SAVE_DIR
fi

echo "python run.py -s $START_DATE -p $DATA_PATH -d $DISK_MODEL -i $ITER_DAYS \
  -v $PATH_SAVE -c $PATH_FEATUERS -r $TRAIN_PATH -e $TEST_PATH -o $OPTIONS \
  -t $FORGET_TYPE -w $POSITIVE_WINDOW -V $VALIDATION_WINDOW -L $NEGATIVE_WINDOW \
  -a $LABEL_DAYS"

echo "python run.py -s $START_DATE -p $DATA_PATH -d $DISK_MODEL -i $ITER_DAYS \
  -v $PATH_SAVE -c $PATH_FEATUERS -r $TRAIN_PATH -e $TEST_PATH -o $OPTIONS \
  -t $FORGET_TYPE -w $POSITIVE_WINDOW -V $VALIDATION_WINDOW -L $NEGATIVE_WINDOW \
  -a $LABEL_DAYS" >> $TIME_PATH

time (python run.py -s $START_DATE -p $DATA_PATH -d "$DISK_MODEL" -i $ITER_DAYS \
  -v $PATH_SAVE -c $PATH_FEATUERS -r $TRAIN_PATH -e $TEST_PATH -o $OPTIONS \
  -t $FORGET_TYPE -w $POSITIVE_WINDOW -V $VALIDATION_WINDOW -L $NEGATIVE_WINDOW \
  -a $LABEL_DAYS) 2>> $TIME_PATH
